/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the MicrosoftAdsStaticDtoAuthorizer type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MicrosoftAdsStaticDtoAuthorizer{}

// MicrosoftAdsStaticDtoAuthorizer struct for MicrosoftAdsStaticDtoAuthorizer
type MicrosoftAdsStaticDtoAuthorizer struct {
	StaticKey      *string `json:"staticKey,omitempty"`
	Label          *string `json:"label,omitempty"`
	DeveloperToken *string `json:"developerToken,omitempty"`
	ClientId       *string `json:"clientId,omitempty"`
	ClientSecret   *string `json:"clientSecret,omitempty"`
	RedirectUri    *string `json:"redirectUri,omitempty"`
	Tenant         *string `json:"tenant,omitempty"`
}

// NewMicrosoftAdsStaticDtoAuthorizer instantiates a new MicrosoftAdsStaticDtoAuthorizer object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMicrosoftAdsStaticDtoAuthorizer() *MicrosoftAdsStaticDtoAuthorizer {
	this := MicrosoftAdsStaticDtoAuthorizer{}
	return &this
}

// NewMicrosoftAdsStaticDtoAuthorizerWithDefaults instantiates a new MicrosoftAdsStaticDtoAuthorizer object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMicrosoftAdsStaticDtoAuthorizerWithDefaults() *MicrosoftAdsStaticDtoAuthorizer {
	this := MicrosoftAdsStaticDtoAuthorizer{}
	return &this
}

// GetStaticKey returns the StaticKey field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticDtoAuthorizer) GetStaticKey() string {
	if o == nil || IsNil(o.StaticKey) {
		var ret string
		return ret
	}
	return *o.StaticKey
}

// GetStaticKeyOk returns a tuple with the StaticKey field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticDtoAuthorizer) GetStaticKeyOk() (*string, bool) {
	if o == nil || IsNil(o.StaticKey) {
		return nil, false
	}
	return o.StaticKey, true
}

// HasStaticKey returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticDtoAuthorizer) HasStaticKey() bool {
	if o != nil && !IsNil(o.StaticKey) {
		return true
	}

	return false
}

// SetStaticKey gets a reference to the given string and assigns it to the StaticKey field.
func (o *MicrosoftAdsStaticDtoAuthorizer) SetStaticKey(v string) {
	o.StaticKey = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticDtoAuthorizer) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticDtoAuthorizer) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticDtoAuthorizer) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *MicrosoftAdsStaticDtoAuthorizer) SetLabel(v string) {
	o.Label = &v
}

// GetDeveloperToken returns the DeveloperToken field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticDtoAuthorizer) GetDeveloperToken() string {
	if o == nil || IsNil(o.DeveloperToken) {
		var ret string
		return ret
	}
	return *o.DeveloperToken
}

// GetDeveloperTokenOk returns a tuple with the DeveloperToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticDtoAuthorizer) GetDeveloperTokenOk() (*string, bool) {
	if o == nil || IsNil(o.DeveloperToken) {
		return nil, false
	}
	return o.DeveloperToken, true
}

// HasDeveloperToken returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticDtoAuthorizer) HasDeveloperToken() bool {
	if o != nil && !IsNil(o.DeveloperToken) {
		return true
	}

	return false
}

// SetDeveloperToken gets a reference to the given string and assigns it to the DeveloperToken field.
func (o *MicrosoftAdsStaticDtoAuthorizer) SetDeveloperToken(v string) {
	o.DeveloperToken = &v
}

// GetClientId returns the ClientId field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticDtoAuthorizer) GetClientId() string {
	if o == nil || IsNil(o.ClientId) {
		var ret string
		return ret
	}
	return *o.ClientId
}

// GetClientIdOk returns a tuple with the ClientId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticDtoAuthorizer) GetClientIdOk() (*string, bool) {
	if o == nil || IsNil(o.ClientId) {
		return nil, false
	}
	return o.ClientId, true
}

// HasClientId returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticDtoAuthorizer) HasClientId() bool {
	if o != nil && !IsNil(o.ClientId) {
		return true
	}

	return false
}

// SetClientId gets a reference to the given string and assigns it to the ClientId field.
func (o *MicrosoftAdsStaticDtoAuthorizer) SetClientId(v string) {
	o.ClientId = &v
}

// GetClientSecret returns the ClientSecret field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticDtoAuthorizer) GetClientSecret() string {
	if o == nil || IsNil(o.ClientSecret) {
		var ret string
		return ret
	}
	return *o.ClientSecret
}

// GetClientSecretOk returns a tuple with the ClientSecret field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticDtoAuthorizer) GetClientSecretOk() (*string, bool) {
	if o == nil || IsNil(o.ClientSecret) {
		return nil, false
	}
	return o.ClientSecret, true
}

// HasClientSecret returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticDtoAuthorizer) HasClientSecret() bool {
	if o != nil && !IsNil(o.ClientSecret) {
		return true
	}

	return false
}

// SetClientSecret gets a reference to the given string and assigns it to the ClientSecret field.
func (o *MicrosoftAdsStaticDtoAuthorizer) SetClientSecret(v string) {
	o.ClientSecret = &v
}

// GetRedirectUri returns the RedirectUri field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticDtoAuthorizer) GetRedirectUri() string {
	if o == nil || IsNil(o.RedirectUri) {
		var ret string
		return ret
	}
	return *o.RedirectUri
}

// GetRedirectUriOk returns a tuple with the RedirectUri field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticDtoAuthorizer) GetRedirectUriOk() (*string, bool) {
	if o == nil || IsNil(o.RedirectUri) {
		return nil, false
	}
	return o.RedirectUri, true
}

// HasRedirectUri returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticDtoAuthorizer) HasRedirectUri() bool {
	if o != nil && !IsNil(o.RedirectUri) {
		return true
	}

	return false
}

// SetRedirectUri gets a reference to the given string and assigns it to the RedirectUri field.
func (o *MicrosoftAdsStaticDtoAuthorizer) SetRedirectUri(v string) {
	o.RedirectUri = &v
}

// GetTenant returns the Tenant field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticDtoAuthorizer) GetTenant() string {
	if o == nil || IsNil(o.Tenant) {
		var ret string
		return ret
	}
	return *o.Tenant
}

// GetTenantOk returns a tuple with the Tenant field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticDtoAuthorizer) GetTenantOk() (*string, bool) {
	if o == nil || IsNil(o.Tenant) {
		return nil, false
	}
	return o.Tenant, true
}

// HasTenant returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticDtoAuthorizer) HasTenant() bool {
	if o != nil && !IsNil(o.Tenant) {
		return true
	}

	return false
}

// SetTenant gets a reference to the given string and assigns it to the Tenant field.
func (o *MicrosoftAdsStaticDtoAuthorizer) SetTenant(v string) {
	o.Tenant = &v
}

func (o MicrosoftAdsStaticDtoAuthorizer) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MicrosoftAdsStaticDtoAuthorizer) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.StaticKey) {
		toSerialize["staticKey"] = o.StaticKey
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.DeveloperToken) {
		toSerialize["developerToken"] = o.DeveloperToken
	}
	if !IsNil(o.ClientId) {
		toSerialize["clientId"] = o.ClientId
	}
	if !IsNil(o.ClientSecret) {
		toSerialize["clientSecret"] = o.ClientSecret
	}
	if !IsNil(o.RedirectUri) {
		toSerialize["redirectUri"] = o.RedirectUri
	}
	if !IsNil(o.Tenant) {
		toSerialize["tenant"] = o.Tenant
	}
	return toSerialize, nil
}

type NullableMicrosoftAdsStaticDtoAuthorizer struct {
	value *MicrosoftAdsStaticDtoAuthorizer
	isSet bool
}

func (v NullableMicrosoftAdsStaticDtoAuthorizer) Get() *MicrosoftAdsStaticDtoAuthorizer {
	return v.value
}

func (v *NullableMicrosoftAdsStaticDtoAuthorizer) Set(val *MicrosoftAdsStaticDtoAuthorizer) {
	v.value = val
	v.isSet = true
}

func (v NullableMicrosoftAdsStaticDtoAuthorizer) IsSet() bool {
	return v.isSet
}

func (v *NullableMicrosoftAdsStaticDtoAuthorizer) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMicrosoftAdsStaticDtoAuthorizer(val *MicrosoftAdsStaticDtoAuthorizer) *NullableMicrosoftAdsStaticDtoAuthorizer {
	return &NullableMicrosoftAdsStaticDtoAuthorizer{value: val, isSet: true}
}

func (v NullableMicrosoftAdsStaticDtoAuthorizer) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMicrosoftAdsStaticDtoAuthorizer) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
